# About

Nitter is a free and open source alternative Twitter front-end focused on
privacy. The source is available on GitHub at <https://github.com/zedeus/nitter>

* No JavaScript or ads
* All requests go through the backend, clients never talk to Twitter
* Prevents Twitter from tracking your IP or JavaScript fingerprint
* Uses unofficial API (no developer account required)
* AGPLv3 licensed, no proprietary instances permitted
* Lightweight (for [@nim_lang](/nim_lang), 36KB vs 580KB from twitter.com)
* Native RSS feeds

Nitter's GitHub wiki contains a list of
[instances](https://github.com/zedeus/nitter/wiki/Instances) and
a list of [browser extensions](https://github.com/zedeus/nitter/wiki/Extensions)
maintained by the community.

## Why use Nitter?

It's basically impossible to use Twitter without JavaScript enabled. If you try,
you're redirected to the legacy mobile version which is awful both functionally
and aesthetically. For privacy-minded folks, preventing JavaScript analytics and
potential IP-based tracking is important, but apart from using the legacy mobile
version and a VPN, it's impossible.

Using an instance of Nitter (hosted on a VPS for example), you can browse
Twitter without JavaScript while retaining your privacy. In addition to
respecting your privacy, Nitter is on average around 15 times lighter than
Twitter, and in some cases serves pages faster.

In the future a simple account system will be added that lets you follow Twitter
users, allowing you to have a clean chronological timeline without needing a
Twitter account.

## Contact

Feel free to join our Freenode IRC channel at #nitter, or our
[Matrix server](https://matrix.to/#/#nitter:matrix.org).
